##GUI functions based on wrapper function to jagsgpdposterior Users enter data based on standard deviations. Output is saved for user but not reported. Assumes many variables have been created
postJacket<-function(ssn=0.0,sst=0.0,soi=0.0,nao=0.0,thin=1,plot="Boxplot", yrange=c(7,16),filename=NULL)
{
testData<-cbind(ssn,sst,soi,nao)
testData<-data.frame(musd[1,]+musd[2,]*testData[,colnames(musd)])
return(jagsgpdposterior(x=jagSampleMatrix, newcov=testData,N=NULL,u=jagsData$u,mask=parmaskgpd,yp=c(1,2,5,10,20,50,100,200,500,1000),mfrow=c(1,1),thin=thin,plot=plot,yrange=sort(yrange),yl=diff(yrange)*2,type="CL2005"))
}

`tomgeneric` <-
function (toolkit, lst, cli = NULL, container = NULL, 
    ...) 
{
    rpel = function(string, envir = .GlobalEnv) {
        eval(parse(text = string), envir = envir)
    }
    theArgs <- list(...)
    if (!is.null(theArgs$fName)) 
        lst <- theArgs$fName
    if (is.character(lst)) {
        if (rpel(Paste("is.function(", lst, ")"))) {
            lst = rpel(autogenerategeneric(lst), environment())
        }
        else {help
            gwCat(paste("Can not create genericwidget from", 
                lst, "\n", sep = " "))
            return(glabel("", cont = container))
        }
    }
    if (!is.list(lst)) {
        warning("ggenericwidget needs to be called with a list, a function name or a function to work\n")
        return(glabel("", cont = container))
    }
    vals = list()
    mainGroup = ggroup(horizontal = FALSE, spacing = 10, container = container, 
        ...)
    if (!is.null(lst$variableType)) {
        if (lst$variableType == "univariate") {
            vals$Data = gunivariate(..., container = mainGroup, 
                anchor = c(-1, 0), expand = TRUE)
        }
        else if (lst$variableType == "univariatetable") {
            vals$Data = gunivariatetable(..., container = mainGroup, 
                anchor = c(-1, 0), expand = TRUE)
        }
        else if (lst$variableType == "fileurl") {
            vals$Data = gfileurl(..., container = mainGroup, 
                anchor = c(-1, 0), expand = TRUE)
        }
        else if (lst$variableType == "bivariate") {
            vals$Data = gbivariate(..., container = mainGroup, 
                anchor = c(-1, 0), expand = TRUE)
        }
        else if (lst$variableType == "model") {
            vals$Data = gmodel(..., container = mainGroup, anchor = c(-1, 
                0), expand = TRUE)
        }
        else if (lst$variableType == "lattice") {
            vals$Data = glattice(..., container = mainGroup, 
                anchor = c(-1, 0), expand = TRUE)
        }
        else if (lst$variableType == "lmer") {
            vals$Data = glmer(..., container = mainGroup, anchor = c(-1, 
                0), expand = TRUE)
        }
        else {
            cat(Paste("Need to implement variableType ", lst$variableType, 
                "\n"))
            vals$Data = NULL
        }
    }
    if (!is.null(lst$arguments)) {
        frame = gframe(text = "Arguments", horizontal = FALSE, 
            cont = mainGroup, anchor = c(-1, 0), expand = TRUE)
        font(frame) <- list(style = "bold", size = 10)
        group = ggroup(horizontal = FALSE, container = frame, expand=T)
        table = glayout(container = group,expand=T)
        trow = 1
        tcol = 1
        addWidgetToDialog = function(name, lstele) {
            if (is.null(lstele$type) || is.list(lstele$type)) {
                if (name != "arguments") {
                  label = glabel(name, cont = table)
                  font(label) <- list(weight = "italic", style = "bold")
                  table[trow, 1:4] <<- label
                 # table[trow, 2:4] <<- gseparator(horizontal = TRUE, 
                 #   cont = table)
                  trow <<- trow + 1
                  tcol <<- 1
                }
                for (i in names(lstele)) {
                  addWidgetToDialog(i, lstele[[i]])
                }
                trow <<- trow + 1
                tcol <<- 1
            }
            else {
                if (!is.list(lstele$type) && lstele$type == "ilabel") {
                  table[trow, 2:4] <<- glabel(lstele$text, cont = table)
                  trow <<- trow + 1
                  tcol <<- 1
                }
                else {
                  table[trow, tcol, anchor = c(1, 0), expand=T] <<- glabel(name, 
                    handler = function(h, ...) {
                      showHelpAtArgument(name, lst$help)
                    }, cont = table)
                  lstele$container = table
                  vals[[name]] <<- do.call(lstele$type, lstele[-1])
                  if(is.list(vals[[name]]))
                  {
                   for(i in 1:length(vals[[name]]))
                   {
                   table[trow,tcol+1,anchor= c(-1,0),expand=T] <<- vals[[name]][[i]]
                   tcol <<- tcol +1
                   }
                  tcol <<- 1
                  trow <<-trow+1
                  }
                  else
                  table[trow, tcol + 1, anchor = c(-1, 0), expand=T] <<- vals[[name]]
                  if (tcol == 3) 
                    trow <<- trow + 1
                  tcol <<- max((tcol + 2)%%4)
                }
            }
        }
        addWidgetToDialog("arguments", lst$arguments)
        visible(table) <- TRUE
    }
    assignto = NULL
    if (!is.null(lst$assignto)) {
        frame = gframe("Assign output to:", cont = mainGroup, 
            anchor = c(-1, 0), expand = TRUE)
        font(frame) <- list(style = "bold")
        print(ifelse(is.character(lst$assignto),lst$assignto,""))
        assignto = gedit(ifelse(is.character(lst$assignto),lst$assignto,""), container = frame)
    }
    ok.cb = function(h, ...) {
        vals = h$action$vals
        lst = h$action$lst
        if (!is.null(h$action$assignto)) 
            assignto = svalue(h$action$assignto)
        head <- lst$action$beginning
        tail <- lst$action$end
        args <- c()
        for (i in names(vals)) {
            val = svalue(vals[[i]])
            if (is.empty(val)) 
                next
            if (i == "..." | i == "Data") {
                args = c(args, val)
            }
            else {
              if(length(val) > 1) val=Paste("c(",Paste(val,collapse=","),")")
                args = c(args, Paste(i, "=", val ))
            }
        }
        str = Paste(head, PasteWithComma(args), tail)
        if (!is.empty(assignto)) 
            names(str) = make.names(assignto)
        else assignto = NULL
        if (is.null(h$action$cli)) {
            cli <- gcommandline(command = str, assignto = assignto, 
                useGUI = FALSE, useConsole = TRUE, container = NULL)
        }
        else {
            cli = h$action$cli
            command <- str
            names(command) <- assignto
            svalue(cli) <- command
        }
    }
    cancel.cb = function(h, ...) {
        action = h$action
        dispose(action)
    }
    help.cb = function(h, ...) {
        helppage = h$action
        win = gwindow(Paste("Help on ", helppage), v = T)
        size(win) <- c(600, 400)
        group = ggroup(horizontal = FALSE, container = win)
        ghelp(topic = helppage, cont = group, expand = TRUE)
        closeGroup = ggroup(container = group)
        addSpring(closeGroup)
        gbutton("cancel", handler = function(h, ...) dispose(win), 
            cont = closeGroup)
    }
    buttongroup = ggroup(container = mainGroup)
    addSpring(buttongroup)
    gbutton("ok", action = list(vals = vals, lst = lst, assignto = assignto, 
        cli = cli), handler = ok.cb, container = buttongroup)
    addSpace(buttongroup, 25)
    gbutton("help", action = lst$help, handler = help.cb, container = buttongroup)
    obj = new("gGenericWidgetANY", block = mainGroup, widget = mainGroup, 
        ID = getNewID(), toolkit = toolkit, lst = lst)
    invisible(obj)
}
environment(tomgeneric)<-environment(gWidgets:::ggenericwidget) #REQUIRED to find 

gslider2<-function(from,to,by,value,...)
{
lapply(1:length(value), function(i) gslider(from = from[i], to = to[i], by = by[i],value=value[i],...=...))
}

svalue.list<-function(obj, index = NULL, drop = NULL, ...) sapply(obj,function(x) svalue(obj=x,index=index,drop=drop,...=...))
setMethod(svalue,signature=signature(obj="list"),svalue.list)
